Attribute VB_Name = "LVAPI"
'Assumed (_WIN32_IE >= =&h0400) and unicode
Option Explicit
Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type POINT
        x As Long
        y As Long
End Type

Public Const WM_NOTIFY = &H4E
Public Type NMHDR
    hwndFrom As Long
    idFrom As Long
    code As Long
End Type

Public Const ICC_LISTVIEW_CLASSES = &H1       ' listview, header
Public Const ICC_TREEVIEW_CLASSES = &H2       ' treeview, tooltips
Public Const ICC_BAR_CLASSES = &H4            ' toolbar, statusbar, trackbar, tooltips
Public Const ICC_TAB_CLASSES = &H8            ' tab, tooltips
Public Const ICC_UPDOWN_CLASS = &H10          ' updown
Public Const ICC_PROGRESS_CLASS = &H20        ' progress
Public Const ICC_HOTKEY_CLASS = &H40          ' hotkey
Public Const ICC_ANIMATE_CLASS = &H80         ' animate
Public Const ICC_WIN95_CLASSES = &HFF
Public Const ICC_DATE_CLASSES = &H100         ' month picker, date picker, time picker, updown
Public Const ICC_USEREX_CLASSES = &H200       ' comboex
Public Const ICC_COOL_CLASSES = &H400         ' rebar (coolbar) control
Public Type ICCE
    dwSize As Long
    dwICC As Long
End Type

Public Declare Function InitCommonControlsEx Lib "comctl32" (lpInitCtrls As ICCE) As Long

Public Declare Function SetFocusAPI Lib "user32" Alias "SetFocus" (ByVal hwnd As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                          (ByVal hwnd As Long, ByVal wMsg As Long, _
                           ByVal wParam As Long, lParam As Any) As Long


Public Const NM_FIRST = 0
Public Const NM_OUTOFMEMORY = (NM_FIRST - 1)
Public Const NM_CLICK = (NM_FIRST - 2)                ' uses NMCLICK struct
Public Const NM_DBLCLK = (NM_FIRST - 3)
Public Const NM_RETURN = (NM_FIRST - 4)
Public Const NM_RCLICK = (NM_FIRST - 5)               ' uses NMCLICK struct
Public Const NM_RDBLCLK = (NM_FIRST - 6)
Public Const NM_SETFOCUS = (NM_FIRST - 7)
Public Const NM_KILLFOCUS = (NM_FIRST - 8)
Public Const NM_CUSTOMDRAW = (NM_FIRST - 12)
Public Const NM_HOVER = (NM_FIRST - 13)
Public Const NM_NCHITTEST = (NM_FIRST - 14)           ' uses NMMOUSE struct
Public Const NM_KEYDOWN = (NM_FIRST - 15)             ' uses NMKEY struct
Public Const NM_RELEASEDCAPTURE = (NM_FIRST - 16)
Public Const NM_SETCURSOR = (NM_FIRST - 17)           ' uses NMMOUSE struct
Public Const NM_CHAR = (NM_FIRST - 18)                ' uses NMCHAR struct

Public Const CCM_FIRST = &H2000                   ' Common control shared messages
Public Const CCM_SETBKCOLOR = (CCM_FIRST + 1)         ' lParam is bkColor
Public Const CCM_SETCOLORSCHEME = (CCM_FIRST + 2)     ' lParam is color scheme
Public Const CCM_GETCOLORSCHEME = (CCM_FIRST + 3)     ' fills in COLORSCHEME pointed to by lParam
Public Const CCM_GETDROPTARGET = (CCM_FIRST + 4)
Public Const CCM_SETUNICODEFORMAT = (CCM_FIRST + 5)
Public Const CCM_GETUNICODEFORMAT = (CCM_FIRST + 6)


Public Type LVITEM
    mask As LVIFEnum
    iItem As Long
    iSubItem As Long
    State As Long
    stateMask As LVISEnum
    pszText As Long
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type

'LVITEM mask
Public Enum LVIFEnum
    LVIF_TEXT = &H1
    LVIF_IMAGE = &H2
    LVIF_PARAM = &H4
    LVIF_STATE = &H8
    LVIF_INDENT = &H10
    LVIF_NORECOMPUTE = &H800
    LVIF_DI_SETITEM = &H1000
End Enum

Public Enum LVISEnum
    LVIS_FOCUSED = &H1
    LVIS_SELECTED = &H2
    LVIS_CUT = &H4
    LVIS_DROPHILITED = &H8
    LVIS_ACTIVATING = &H20
    LVIS_OVERLAYMASK = &HF00
    LVIS_STATEIMAGEMASK = &HF000
End Enum

'Columns
Public Type LVCOLUMN
    mask As LVCFEnum
    fmt As LVCFMTEnum
    cx As Long
    lpszText As Long
    cchTextMax As Long
    subitem As Long
    iImage As Long
    iOrder As Long
End Type

Public Enum LVCFEnum
    LVCF_FMT = &H1
    LVCF_WIDTH = &H2
    LVCF_TEXT = &H4
    LVCF_SUBITEM = &H8
    LVCF_IMAGE = &H10
    LVCF_ORDER = &H20
End Enum
 
Public Enum LVCFMTEnum
    LVCFMT_LEFT = &H0
    LVCFMT_RIGHT = &H1
    LVCFMT_CENTER = &H2
    LVCFMT_JUSTIFYMASK = &H3
    LVCFMT_IMAGE = &H800
    LVCFMT_BITMAP_ON_RIGHT = &H1000
    LVCFMT_COL_HAS_IMAGES = &H8000
End Enum
'

Public Type LVFINDINFO
    flags As Long
    psz As Long
    lParam As Long
    pt As POINT
    vkDirection As Long
End Type

Public Type LVHITTESTINFO
    pt As POINT
    flags As Long
    item As Long
    subitem As Long    ' this is was NOT in win95.  valid only for LVM_SUBITEMHITTEST
End Type

Public Type LVBKIMAGEW
     ulFlags As Long
     hbm As Long
     pszImage As Long
     cchImageMax As Long
     xOffsetPercent As Long
     yOffsetPercent As Long
End Type

Public Type NMLVGETINFOTIPA
    nmh As NMHDR
    flags As Long
    strPtr As Long
    cchTextMax As Long
    item As Long
    subitem As Long
    lParam As Long
End Type

Public Type NMLVGETINFOTIP
    nmh As NMHDR
    dwFlags As Long
    strPtr As Long
    cchTextMax As Long
    item As Long
    subitem As Long
    lParam As Long
End Type

Public Type NMLISTVIEW
    nmh As NMHDR
    iItem  As Long
    iSubItem As Long
    uNewState As Long
    uOldState As Long
    uChanged As Long
    ptAction As POINT
    lParam As Long
End Type
' NMITEMACTIVATE is used instead of NMLISTVIEW in IE >= =&h400
' therefore all the fields are the same except for extra uKeyFlags
' they are used to store key flags at the time of the single click with
' delayed activation - because by the time the timer goes off a user may
' not hold the keys (shift, ctrl) any more
Public Type NMITEMACTIVATE
    nmh As NMHDR
    iItem As Long
    iSubItem As Long
    uNewState As Long
    uOldState As Long
    uChanged As Long
    ptAction As POINT
    lParam As Long
    uKeyFlags As Long
End Type

' key flags stored in uKeyFlags
Public Const LVKF_ALT = &H1
Public Const LVKF_CONTROL = &H2
Public Const LVKF_SHIFT = &H4

Public Type NMLVCACHEHINT
    nmh As NMHDR
    iFrom As Long
    iTo As Long
End Type

Public Type NMLVFINDITEM
    nmh As NMHDR
    iStart As Long
    lvfi As LVFINDINFO
End Type

Public Type NMLVODSTATECHANGE
    nmh As NMHDR
    iFrom As Long
    iTo As Long
    uNewState As Long
    uOldState As Long
End Type

Public Const LVN_FIRST = -100
Public Const LVN_ITEMCHANGING = (LVN_FIRST - 0)
Public Const LVN_ITEMCHANGED = (LVN_FIRST - 1)
Public Const LVN_INSERTITEM = (LVN_FIRST - 2)
Public Const LVN_DELETEITEM = (LVN_FIRST - 3)
Public Const LVN_DELETEALLITEMS = (LVN_FIRST - 4)
Public Const LVN_BEGINLABELEDITA = (LVN_FIRST - 5)
Public Const LVN_BEGINLABELEDITW = (LVN_FIRST - 75)
Public Const LVN_ENDLABELEDITA = (LVN_FIRST - 6)
Public Const LVN_ENDLABELEDITW = (LVN_FIRST - 76)
Public Const LVN_COLUMNCLICK = (LVN_FIRST - 8)
Public Const LVN_BEGINDRAG = (LVN_FIRST - 9)
Public Const LVN_BEGINRDRAG = (LVN_FIRST - 11)
Public Const LVN_ODCACHEHINT = (LVN_FIRST - 13)
Public Const LVN_ODFINDITEMA = (LVN_FIRST - 52)
Public Const LVN_ODFINDITEM = (LVN_FIRST - 79)
Public Const LVN_ITEMACTIVATE = (LVN_FIRST - 14)
Public Const LVN_ODSTATECHANGED = (LVN_FIRST - 15)
Public Const LVN_HOTTRACK = (LVN_FIRST - 21)
Public Const LVN_GETDISPINFOA = (LVN_FIRST - 50)
Public Const LVN_GETDISPINFO = (LVN_FIRST - 77)
Public Const LVN_SETDISPINFOA = (LVN_FIRST - 51)
Public Const LVN_SETDISPINFO = (LVN_FIRST - 78)
Public Const LVN_KEYDOWN = (LVN_FIRST - 55)
Public Const LVN_MARQUEEBEGIN = (LVN_FIRST - 56)
Public Const LVN_GETINFOTIPA = (LVN_FIRST - 57)
Public Const LVN_GETINFOTIP = (LVN_FIRST - 58)


Public Const LVBKIF_SOURCE_NONE = &H0
Public Const LVBKIF_SOURCE_HBITMAP = &H1
Public Const LVBKIF_SOURCE_URL = &H2
Public Const LVBKIF_SOURCE_MASK = &H3
Public Const LVBKIF_STYLE_NORMAL = &H0
Public Const LVBKIF_STYLE_TILE = &H10
Public Const LVBKIF_STYLE_MASK = &H10

Public Type LVDISPINFO
    nmh As NMHDR
    i As LVITEM
End Type

Public Type NMLVKEYDOWN
    nmh As NMHDR
    wVKey As Integer
    flags As Long
End Type

Public Const LVGIT_UNFOLDED = &H1

'Styles
Public Const LVS_ICON = &H0
Public Const LVS_REPORT = &H1
Public Const LVS_SMALLICON = &H2
Public Const LVS_LIST = &H3
Public Const LVS_TYPEMASK = &H3
Public Const LVS_SINGLESEL = &H4
Public Const LVS_SHOWSELALWAYS = &H8
Public Const LVS_SORTASCENDING = &H10
Public Const LVS_SORTDESCENDING = &H20
Public Const LVS_SHAREIMAGELISTS = &H40
Public Const LVS_NOLABELWRAP = &H80
Public Const LVS_AUTOARRANGE = &H100
Public Const LVS_EDITLABELS = &H200
Public Const LVS_OWNERDATA = &H1000
Public Const LVS_NOSCROLL = &H2000
Public Const LVS_TYPESTYLEMASK = &HFC00
Public Const LVS_ALIGNTOP = &H0
Public Const LVS_ALIGNLEFT = &H800
Public Const LVS_ALIGNMASK = &HC00
Public Const LVS_OWNERDRAWFIXED = &H400
Public Const LVS_NOCOLUMNHEADER = &H4000
Public Const LVS_NOSORTHEADER = &H8000

Public Const LVS_EX_GRIDLINES = &H1
Public Const LVS_EX_SUBITEMIMAGES = &H2
Public Const LVS_EX_CHECKBOXES = &H4
Public Const LVS_EX_TRACKSELECT = &H8
Public Const LVS_EX_HEADERDRAGDROP = &H10
Public Const LVS_EX_FULLROWSELECT = &H20         ' applies to report mode only
Public Const LVS_EX_ONECLICKACTIVATE = &H40
Public Const LVS_EX_TWOCLICKACTIVATE = &H80
Public Const LVS_EX_FLATSB = &H100
Public Const LVS_EX_REGIONAL = &H200
Public Const LVS_EX_INFOTIP = &H400              ' listview does InfoTips for you
Public Const LVS_EX_UNDERLINEHOT = &H800
Public Const LVS_EX_UNDERLINECOLD = &H1000
Public Const LVS_EX_MULTIWORKAREAS = &H2000

Public Const LVSIL_NORMAL = 0
Public Const LVSIL_SMALL = 1
Public Const LVSIL_STATE = 2

Public Const LVNI_ALL = &H0
Public Const LVNI_FOCUSED = &H1
Public Const LVNI_SELECTED = &H2
Public Const LVNI_CUT = &H4
Public Const LVNI_DROPHILITED = &H8
Public Const LVNI_ABOVE = &H100
Public Const LVNI_BELOW = &H200
Public Const LVNI_TOLEFT = &H400
Public Const LVNI_TORIGHT = &H800


Public Const LVHT_NOWHERE = &H1
Public Const LVHT_ONITEMICON = &H2
Public Const LVHT_ONITEMLABEL = &H4
Public Const LVHT_ONITEMSTATEICON = &H8
Public Const LVHT_ONITEM = (LVHT_ONITEMICON Or LVHT_ONITEMLABEL Or LVHT_ONITEMSTATEICON)

Public Const LVHT_ABOVE = &H8
Public Const LVHT_BELOW = &H10
Public Const LVHT_TORIGHT = &H20
Public Const LVHT_TOLEFT = &H40

Public Const LVFI_PARAM = &H1
Public Const LVFI_STRING = &H2
Public Const LVFI_PARTIAL = &H8
Public Const LVFI_WRAP = &H20
Public Const LVFI_NEARESTXY = &H40

Public Const LVIR_BOUNDS = 0
Public Const LVIR_ICON = 1
Public Const LVIR_LABEL = 2
Public Const LVIR_SELECTBOUNDS = 3
Public Const LV_MAX_WORKAREAS = 16

Public Const LVA_DEFAULT = &H0
Public Const LVA_ALIGNLEFT = &H1
Public Const LVA_ALIGNTOP = &H2
Public Const LVA_SNAPTOGRID = &H5

' these flags only apply to LVS_OWNERDATA listviews in report or list mode
Public Const LVSICF_NOINVALIDATEALL = &H1
Public Const LVSICF_NOSCROLL = &H2
Public Const LVSCW_AUTOSIZE = -1
Public Const LVSCW_AUTOSIZE_USEHEADER = -2



'messages
Public Const LVM_FIRST = &H1000
Public Const LVM_GETBKCOLOR = (LVM_FIRST + 0)
Public Const LVM_SETBKCOLOR = (LVM_FIRST + 1)
Public Const LVM_GETIMAGELIST = (LVM_FIRST + 2)
Public Const LVM_SETIMAGELIST = (LVM_FIRST + 3)
Public Const LVM_GETITEMCOUNT = (LVM_FIRST + 4)

Public Const LVM_DELETEITEM = (LVM_FIRST + 8)
Public Const LVM_DELETEALLITEMS = (LVM_FIRST + 9)
Public Const LVM_GETCALLBACKMASK = (LVM_FIRST + 10)
Public Const LVM_SETCALLBACKMASK = (LVM_FIRST + 11)
Public Const LVM_GETNEXTITEM = (LVM_FIRST + 12)
Public Const LVM_GETITEMRECT = (LVM_FIRST + 14)
Public Const LVM_SETITEMPOSITION = (LVM_FIRST + 15)
Public Const LVM_GETITEMPOSITION = (LVM_FIRST + 16)
Public Const LVM_HITTEST = (LVM_FIRST + 18)
Public Const LVM_ENSUREVISIBLE = (LVM_FIRST + 19)
Public Const LVM_SCROLL = (LVM_FIRST + 20)
Public Const LVM_REDRAWITEMS = (LVM_FIRST + 21)
Public Const LVM_ARRANGE = (LVM_FIRST + 22)
'public const LVM_EDITLABELA          (LVM_FIRST + 23)
Public Const LVM_EDITLABELW = (LVM_FIRST + 118)
Public Const LVM_GETEDITCONTROL = (LVM_FIRST + 24)
'public const LVM_GETCOLUMNA          (LVM_FIRST + 25)
Public Const LVM_GETCOLUMNW = (LVM_FIRST + 95)
'public const LVM_SETCOLUMNA          (LVM_FIRST + 26)
Public Const LVM_SETCOLUMNW = (LVM_FIRST + 96)
'public const LVM_INSERTCOLUMNA       (LVM_FIRST + 27)
Public Const LVM_INSERTCOLUMNW = (LVM_FIRST + 97)
Public Const LVM_DELETECOLUMN = (LVM_FIRST + 28)
Public Const LVM_GETCOLUMNWIDTH = (LVM_FIRST + 29)
Public Const LVM_SETCOLUMNWIDTH = (LVM_FIRST + 30)
Public Const LVM_GETHEADER = (LVM_FIRST + 31)
Public Const LVM_CREATEDRAGIMAGE = (LVM_FIRST + 33)
Public Const LVM_GETVIEWRECT = (LVM_FIRST + 34)
Public Const LVM_GETTEXTCOLOR = (LVM_FIRST + 35)
Public Const LVM_SETTEXTCOLOR = (LVM_FIRST + 36)
Public Const LVM_GETTEXTBKCOLOR = (LVM_FIRST + 37)
Public Const LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38)
Public Const LVM_GETTOPINDEX = (LVM_FIRST + 39)
Public Const LVM_GETCOUNTPERPAGE = (LVM_FIRST + 40)
Public Const LVM_GETORIGIN = (LVM_FIRST + 41)
Public Const LVM_UPDATE = (LVM_FIRST + 42)
Public Const LVM_SETITEMSTATE = (LVM_FIRST + 43)
Public Const LVM_GETITEMSTATE = (LVM_FIRST + 44)
Public Const LVM_GETITEMTEXTA = (LVM_FIRST + 45)
Public Const LVM_GETITEMTEXTW = (LVM_FIRST + 115)
Public Const LVM_SETITEMTEXTA = (LVM_FIRST + 46)
Public Const LVM_SETITEMTEXTW = (LVM_FIRST + 116)
Public Const LVM_SETITEMCOUNT = (LVM_FIRST + 47)
Public Const LVM_SORTITEMS = (LVM_FIRST + 48)
Public Const LVM_SETITEMPOSITION32 = (LVM_FIRST + 49)
Public Const LVM_GETSELECTEDCOUNT = (LVM_FIRST + 50)
Public Const LVM_GETITEMSPACING = (LVM_FIRST + 51)
Public Const LVM_GETISEARCHSTRINGA = (LVM_FIRST + 52)
Public Const LVM_GETISEARCHSTRING = (LVM_FIRST + 117)
Public Const LVM_SETICONSPACING = (LVM_FIRST + 53)
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54)  ' optional wParam == mask
Public Const LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)
Public Const LVM_GETSUBITEMRECT = (LVM_FIRST + 56)
Public Const LVM_SUBITEMHITTEST = (LVM_FIRST + 57)
Public Const LVM_SETCOLUMNORDERARRAY = (LVM_FIRST + 58)
Public Const LVM_GETCOLUMNORDERARRAY = (LVM_FIRST + 59)
Public Const LVM_SETHOTITEM = (LVM_FIRST + 60)
Public Const LVM_GETHOTITEM = (LVM_FIRST + 61)
Public Const LVM_SETHOTCURSOR = (LVM_FIRST + 62)
Public Const LVM_GETHOTCURSOR = (LVM_FIRST + 63)
Public Const LVM_APPROXIMATEVIEWRECT = (LVM_FIRST + 64)
Public Const LVM_SETWORKAREAS = (LVM_FIRST + 65)
Public Const LVM_GETSELECTIONMARK = (LVM_FIRST + 66)
Public Const LVM_SETSELECTIONMARK = (LVM_FIRST + 67)
Public Const LVM_SETBKIMAGEA = (LVM_FIRST + 68)
Public Const LVM_GETBKIMAGEA = (LVM_FIRST + 69)
Public Const LVM_GETWORKAREAS = (LVM_FIRST + 70)
Public Const LVM_SETHOVERTIME = (LVM_FIRST + 71)
Public Const LVM_GETHOVERTIME = (LVM_FIRST + 72)
Public Const LVM_GETNUMBEROFWORKAREAS = (LVM_FIRST + 73)
Public Const LVM_SETTOOLTIPS = (LVM_FIRST + 74)
Public Const LVM_GETITEM = (LVM_FIRST + 75)
Public Const LVM_SETITEM = (LVM_FIRST + 76)
Public Const LVM_INSERTITEM = (LVM_FIRST + 77)
Public Const LVM_GETTOOLTIPS = (LVM_FIRST + 78)
Public Const LVM_FINDITEMW = (LVM_FIRST + 83)
Public Const LVM_GETSTRINGWIDTHW = (LVM_FIRST + 87)
Public Const LVM_SETBKIMAGEW = (LVM_FIRST + 138)
Public Const LVM_GETBKIMAGEW = (LVM_FIRST + 139)

Private myClients As Collection
Public Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Const WM_KEYDOWN = &H100
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Public Const WM_KILLFOCUS = &H8


'Hook to window message loop and return old proc address
Public Function RegisterLV(ByVal Ctl_ As ListViewCtl, ByVal hwnd_ As Long) As Long
468 If myClients Is Nothing Then Set myClients = New Collection
469 Dim oldaddr_ As Long
470 oldaddr_ = SetWindowLong(hwnd_, GWL_WNDPROC, AddressOf myWndProc)
471 RegisterLV = oldaddr_
472 On Error Resume Next
473 myClients.Add Ctl_, "W" & hwnd_
474 If Err Then SetWindowLong hwnd_, GWL_WNDPROC, oldaddr_   'can't register user
End Function

Public Function UnRegisterLV(ByVal hwnd_ As Long, ByVal OldWinProc As Long) As Long
479 Dim oldaddr_ As Long
480 oldaddr_ = SetWindowLong(hwnd_, GWL_WNDPROC, OldWinProc)
482 UnRegisterLV = oldaddr_
483 On Error Resume Next
484 myClients.Remove ("W" & hwnd_)
485 If myClients.Count = 0 Then Set myClients = Nothing
On Error GoTo 0
End Function

Private Function myWndProc(ByVal hwnd_ As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
514 Dim o_ As ListViewCtl
515 If myClients Is Nothing Then Exit Function
516 If myClients.Count = 0 Then Exit Function
517 On Error Resume Next
518 Set o_ = myClients("W" & hwnd_)
519 If Not o_ Is Nothing Then myWndProc = o_.WndProc(hwnd_, uMsg, wParam, lParam)      'get by ListViewCtl collection ket
End Function
